/*
 * Copyright (c) 1998-2008 TeamDev Ltd. All Rights Reserved.
 * Use is subject to license terms.
 */
package com.teamdev.xpcom.mozilla.demo;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.net.URL;

import javax.swing.JComponent;

import sun.awt.image.URLImageSource;

/**
 * @author Ikryanov Vladimir
 */
public class LoaderImage extends JComponent
{
    private static final long serialVersionUID = 2390856049716582609L;

    private static final URL FREE = LoaderImage.class.getResource("res/Throbber-small.png");

    private static final URL BUSY = LoaderImage.class.getResource("res/Throbber-small.gif");

    private Image _image;

    public LoaderImage()
    {
    }

    public void setLoadingMode(boolean isLoading)
    {
        if (!isLoading)
        {
            _image = this.createImage(new URLImageSource(FREE));
        }
        else
        {
            _image = this.createImage(new URLImageSource(BUSY));
        }

        MediaTracker mediaTracker = new MediaTracker(this);
        mediaTracker.addImage(_image, 0);
        try
        {
            mediaTracker.waitForAll();
        }
        catch (InterruptedException e)
        {
            e.printStackTrace();
        }

        repaint();
    }

    public void paint(Graphics graphics)
    {
        if (_image != null)
        {
            graphics.drawImage(_image, 0, 0, this);
        }
    }

    public boolean imageUpdate(Image img, int infoflags, int x, int y, int w, int h)
    {
        if (_image.equals(img)) { return super.imageUpdate(img, infoflags, x, y, w, h); }
        return false;
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(_image.getWidth(this), _image.getHeight(this));
    }

    public Dimension getMinimumSize()
    {
        return getPreferredSize();
    }
}
